﻿//Copyright (C) 2013 Hosnieh Rafiee, Hasso-Plattner-Institut fuer Softwaresystemtechnik Potsdam GmbH
//#    ietf{at}rozanak.com

//# This file is part of then comparison made between the privacy extension and ra privacy.

//# This software is free: you can redistribute and/or modify it
//# It is used under the terms of the GNU General Public License as published by
//# The Free Software Foundation, either version 3 of the License, or
//# (at your option) any later version.

//# This program is provided WITHOUT ANY WARRANTY; without even an implied warranty of
//# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//# GNU General Public License for more details.

//# You should have received a copy of the GNU General Public License
//# along with this code. If not, see <http://www.gnu.org/licenses/ .


using System;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Globalization;

namespace md5_Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] random = RandomGenerator(8);


            StringBuilder sBuilder = new StringBuilder();
            for (int i = 0; i < random.Length; i++)
            {

                sBuilder.Append(random[i].ToString("x2"));
            }
            randomNumber.Text = sBuilder.ToString();

            sBuilder.Clear();
            byte[] digest = StringToByteArray(randomNumber.Text.Trim() + txtip.Text.Trim());

            string tmp = MD5hashGen(digest);
               txtresult.Text += tmp + Environment.NewLine;

               randomNumber.Text = txtresult.Text.Substring(txtresult.Text.Length - 18, 16);
               txtiid1.Text = tmp.Substring(0, 16);
          
           
        }
        public static byte[] StringToByteArray(string hex)
        {
            return Enumerable.Range(0, hex.Length)
                             .Where(x => x % 2 == 0)
                             .Select(x => Convert.ToByte(hex.Substring(x, 2), 16))
                             .ToArray();
        }
        static string MD5hashGen( byte[] input)
        {
            MD5 md5Hash = MD5.Create();


            byte[] data = md5Hash.ComputeHash(input);

            StringBuilder sBuilder = new StringBuilder();
          
            for (int i = 0; i < data.Length; i++)
            {
              
                sBuilder.Append(data[i].ToString("x2"));
            }
           

            // Return the hexadecimal string. 
          return sBuilder.ToString();
            //return data;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            byte[] modifier= RandomGenerator(16);
          
      
           StringBuilder sBuilder = new StringBuilder();
            for (int i = 0; i < modifier.Length; i++)
            {
              
                sBuilder.Append(modifier[i].ToString("x2"));
            }
            txtmodifier.Text = sBuilder.ToString();

            sBuilder.Clear();

           CultureInfo MyCultureInfo = new CultureInfo("de-DE");
      string stringdate = "01 januar 1970 00:00:00";
      DateTime newdate = DateTime.Parse(stringdate, MyCultureInfo, 
                                           DateTimeStyles.NoCurrentDateDefault);
     TimeSpan tm= DateTime.UtcNow.Subtract(newdate);

     long nanoseconds = tm.Ticks;
     byte[] mybyt = BitConverter.GetBytes(nanoseconds);

             for (int i = 0; i < mybyt.Length; i++)
            {
              
                sBuilder.Append(mybyt[i].ToString("x2"));
            }
             txttimestamp.Text = sBuilder.ToString();

            byte[] ip = StringToByteArray(txtmodifier.Text.Trim() + txttimestamp.Text.Trim() + txtprefix.Text);
            byte[] date1=SHAEncrypt(ip, flag.SHA256);
            sBuilder.Clear();
            for (int i = 0; i < date1.Length; i++)
            {

                sBuilder.Append(date1[i].ToString("x2"));
            }
            txtresultra.Text += sBuilder.ToString() + Environment.NewLine;

            txtIID.Text = sBuilder.ToString().Substring(0, 16);
           
        }
        enum flag
        {
            SHA1 = 0,
            SHA256 = 1,
            SHA384 = 2,
            SHA512 = 3

        }
        private byte[] SHAEncrypt(byte[] data, flag f)
        {


            byte[] result = null;

            switch (f)
            {
                case flag.SHA1:
                    SHA1 sha = new SHA1CryptoServiceProvider();
                    result = sha.ComputeHash(data);
                    break;
                case flag.SHA256:
                    SHA256 sha1 = new SHA256CryptoServiceProvider();
                    result = sha1.ComputeHash(data);
                    break;
                case flag.SHA384:
                    SHA384 sha2 = new SHA384CryptoServiceProvider();
                    result = sha2.ComputeHash(data);
                    break;
                case flag.SHA512:
                    SHA512 sha3 = new SHA512CryptoServiceProvider();
                    result = sha3.ComputeHash(data);
                    break;


            }
            // This is one implementation of the abstract class SHA1.

            return result;
        }
        // modifier is 128 bit or 16 byte and decimal is 16 byte too

        // generate random number by giving it the number of bytes
        public byte[] RandomGenerator(int arrysize)
        {
            byte[] bytes1 = new byte[arrysize];

            Random rnd1 = new Random();
            rnd1.NextBytes(bytes1);
            return bytes1;
        }


    }
}
